/* ### Modified by P. Saratxaga on 25 Oct 1995 ###
 * - added aftercall(nlent)  (code from T.Tanaka)
 */
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "lutil.h"
#include "xutil.h"
#include "ftn.h"
#include "nodelist.h"
#include "config.h"
#include "session.h"
#include "callstat.h"
#ifdef HAVE_TXY
#include "Txy.h"
#endif

#ifdef IFCS
#include "ifcs.h"
extern shmData_ *shmData;
void ipcloginf(int, char*,...);
#endif

extern int forcedcalls;
extern char *forcedphone;
extern char *forcedline;
extern char *inetaddr;
extern void setnamesfx(char*);

/* ************************* */
extern int aftercall(node *);

extern char *get_modem_string(modem_string*,node*);
extern int openport(char*,int);
#if defined(HAS_TCP) || defined(HAS_TERM)
extern int opentcp(char*);
extern void closetcp(void);
#endif
extern void localport(void);
extern void nolocalport(void);
extern void closeport(void);
extern int dialphone(node*,char*);
extern int hangup(node*);
extern void rdoptions(node*);
extern int nodelock(faddr*);
extern int nodeulock(faddr*);
extern void setproctitle(char*);

#ifdef HIDDENS
#define MAXLINES 16
extern fa_list *Hidden;
extern fa_list *Override;
extern unsigned int call_line, call_lines;
char *parsehidden(node *, char *);
node *setline(faddr *, callstat *);
#endif

int checkretry(st)
callstat *st;
{
	return 0;
	/* check retries and time; rc=1 - not reached, rc=2 - undialable */
}

int call(addr)
faddr *addr;
{
	node *nlent;
	int rc=1;
	int speed=0;
	char *portlist,*p,*q;
	callstat *st;
	char cbuf[128];

	st=getstatus(addr);

	nlent = setline(addr, st);

	if (!forcedphone && !nlent->phone && !inetaddr)
	{
		loginf("cannot call %s: no working line(s)",
			ascfnode(addr,0x1f));
#ifdef IFCS
		ipcloginf(5, "cannot call %s: no working line(s)",
			ascfnode(addr,0x1f));
#endif
		putstatus(addr,0,8);
		return 8;
	}

	if (!forcedcalls) {
		if ((rc=checkretry(st))) {
			loginf("cannot call %s: %s",
				ascfnode(addr,0x1f),
				(rc==1)?"retry time not reached"
				:"node undialable");
#ifdef IFCS
			ipcloginf(7, "cannot call %s: %s",
				ascfnode(addr,0x1f),
				(rc==1)?"retry time not reached"
				:"node undialable");
#endif
			putstatus(addr,0,5);
			return 5;
		}
		if (dialdelay) 
		    {
#ifdef IFCS
		    ipcloginf(1, "pause %u seconds...", dialdelay);
#endif
		    sleep(dialdelay);
		    }
	}

	if (nodelock(addr))
	{
		loginf("system %s locked",ascinode(addr,0x1f));
#ifdef IFCS
		ipcloginf(7, "system %s locked",ascinode(addr,0x1f));
#endif
		putstatus(addr,0,4);
		return 4;
	}

	localoptions = 0;
	rdoptions(nlent);

	inbound=protinbound; /* master sessions are secure */

#ifdef IFCS
	if(shmData) shmData->SesProtected = 1;
#endif
	if ((nlent->phone != NULL) && (!strncmp(nlent->phone,"            ",12))) nlent->phone = NULL;

	sprintf(cbuf,"ifcico calling %s (%s %s)",
		ascfnode(&(nlent->addr),0x1f),
#if defined(HAS_TCP) || defined(HAS_TERM)
		inetaddr?"addr":"phone",
		inetaddr?inetaddr:
#else
		"phone",
#endif
			forcedphone?forcedphone:
				nlent->phone?nlent->phone:"<none>");
	setproctitle(cbuf);

	if ((nlent->phone || forcedphone
#if defined(HAS_TCP) || defined(HAS_TERM)
					 || inetaddr
#endif
							) &&
	    (forcedcalls || !(localoptions & NOCALL)))

	{
#if defined(HAS_TCP) || defined(HAS_TERM)
		loginf("calling %s (%s, %s %s"
#ifdef HIDDENS
				    " [%u] of %u"
#endif
						")",
			ascfnode(addr,0x1f),nlent->name,
			inetaddr?"addr":"phone",
			inetaddr?inetaddr:
			forcedphone?forcedphone:nlent->phone
#ifdef HIDDENS
			,forcedphone?1:call_line+1, forcedphone?1:call_lines
#endif
			);
#else
		loginf("calling %s (%s, phone %s"
#ifdef HIDDENS
					    " [%u] of %u"
#endif
							")",
			ascfnode(addr,0x1f),nlent->name,
			forcedphone?forcedphone:nlent->phone
#ifdef HIDDENS
			,forcedphone?1:call_line+1, forcedphone?1:call_lines
#endif
			);
#endif

#ifdef IFCS
#if defined(HAS_TCP) || defined(HAS_TERM)
		ipcloginf(5, "calling %s (%s, %s %s"
#ifdef HIDDENS
				    " [%u/%u]"
#endif
						")",
			ascfnode(addr,0x1f),nlent->name,
			inetaddr?"addr":"phone",
			inetaddr?inetaddr:
			forcedphone?forcedphone:nlent->phone
#ifdef HIDDENS
			,forcedphone?1:call_line+1, forcedphone?1:call_lines
#endif
			);
#else
		ipcloginf(5, "calling %s (%s, phone %s"
#ifdef HIDDENS
					    " [%u/%u]"
#endif
							")",
			ascfnode(addr,0x1f),nlent->name,
			forcedphone?forcedphone:nlent->phone
#ifdef HIDDENS
			,forcedphone?1:call_line+1, forcedphone?1:call_lines
#endif
			);
#endif
#endif

#if defined(HAS_TCP) || defined(HAS_TERM)
		if (inetaddr)
		{
			rc=opentcp(inetaddr);
			if (rc)
			{
				loginf("cannot connect %s",inetaddr);
#ifdef IFCS
				ipcloginf(7, "cannot connect %s",inetaddr);
#endif
				nodeulock(addr);
				putstatus(addr,1,2);
				return 2;
			}
		}
		else
#endif
		     if (forcedline)
		{
			p=forcedline;
			if ((q=strchr(p,':')))
			{
				*q++='\0';
				if ((*q == 'l') || (*q == 'L'))
					speed=atoi(++q);
				else
				{
					speed=atoi(q);
					if (nlent->speed < speed)
						speed=nlent->speed;
				}
			}
			else speed=0;
			setnamesfx(p);
			rc=openport(p,speed);
			if (rc)
			{
				loginf("cannot open port %s",p);
#ifdef IFCS
				ipcloginf(7, "cannot open port %s",p);
#endif
				nodeulock(addr);
				putstatus(addr,0,1);
				return 1;
			}
		}
		else
		{
			if ((portlist=xstrcpy(get_modem_string(modemport,nlent))) == NULL)
			{
				loginf("no matching ports defined");
#ifdef IFCS
				ipcloginf(7, "no matching ports defined");
#endif
				nodeulock(addr);
				putstatus(addr,0,9);
				return 9;
			}
			for (rc=1,p=strtok(portlist," \t,");
				rc && p;
				p=strtok(NULL," \t,"))
			{
				if ((q=strrchr(p,':')))
				{
					*q++='\0';
					if ((*q == 'l') || (*q == 'L'))
					{
						speed=atoi(++q);
					}
					else
					{
						speed=atoi(q);
						if (nlent->speed < speed)
							speed=nlent->speed;
					}
				}
				else speed=0;
				setnamesfx(p);
				rc=openport(p,speed);
			}
			if (rc)
			{
				loginf("no free matching ports");
#ifdef IFCS
			ipcloginf(7, "no free matching ports");
#endif
				free(portlist);
				nodeulock(addr);
				putstatus(addr,0,1);
				return 1;
			}
			free(portlist);
		}

#ifdef IFCS
#if defined(HAS_TCP) || defined(HAS_TERM)
		if (!inetaddr)
		    {
#endif
		    if(shmData)
			{
			strcpy(shmData->tty, ttyname(0));
			shmData->ttyspeed=speed;
			}
#if defined(HAS_TCP) || defined(HAS_TERM)
		    }
		else if(shmData) strcpy(shmData->tty, "TCP");
#endif
#endif

#if defined(HAS_TCP) || defined(HAS_TERM)
		if (!inetaddr)
#endif
		if ((rc=dialphone(nlent,forcedphone?forcedphone:nlent->phone)))
		{
			loginf("dial failed");
#ifdef IFCS
		    ipcloginf(7, "dial failed");
#endif
			nodeulock(addr);
			rc+=1; /* rc=2 - dial fail, rc=3 - could not reset */
		}

		if (rc == 0)
		{
#if defined(HAS_TCP) || defined(HAS_TERM)
			if (!inetaddr)
#endif
				nolocalport();
			rc=session(addr,nlent,SESSION_MASTER,
				SESSION_UNKNOWN,NULL);
			if (rc) rc=abs(rc)+10;
		}
#if defined(HAS_TCP) || defined(HAS_TERM)
		if (inetaddr)
		{
			closetcp();
		}
		else
#endif
		{
			localport();
			hangup(nlent);
			aftercall(nlent);
			closeport();
		}
	}
	else
	{
		loginf("cannot call %s (%s, phone %s)",
			ascfnode(addr,0x1f),S(nlent->name),
			S(nlent->phone));
#ifdef IFCS
		    ipcloginf(7, "cannot call %s", ascfnode(addr,0x1f));
#endif

		if ((nlent->phone || forcedphone
#if defined(HAS_TCP) || defined(HAS_TERM)
						 || inetaddr
#endif
								))
			rc=8;
		else rc=7;
		nodeulock(addr);
	}

	if ((rc == 2) || (rc == 30))
		putstatus(addr,1,rc);
	else
		putstatus(addr,0,rc);
	return rc;
}
#ifdef HIDDENS
char *parsehidden(node *nlent, char *str)
{
char *dump, *p, *sep=" \t", *phone=NULL, *time=NULL;
 
debug(6,"got string: \"%s\"",str);
 
dump=strdup(str);
    
if((p=strtok(dump, sep))) phone=strdup(p);
else
    {
    debug(6,"error parsing phone");
    free(dump);
    return NULL;
    }
    
if((p=strtok(NULL, sep)))
    {
    time=strdup(p);
    
    if(!checkWorkTime(nlent, time, -1, -1, -1))
	{
	debug(6,"phone %s is not work now", phone);
	free(phone);
	free(time);
	free(dump);
	return NULL;
	}
    }
else
    {
    debug(6,"error parsing time");
    free(phone);
    free(dump);
    return NULL;
    }
free(dump);
free(time);
return phone;
}
#endif

node *setline(faddr *addr, callstat *st)
{
node *nlent;
int i, tryline, lines=0;
static char phonebuf[256];
#ifdef HIDDENS
fa_list *tmp;
char *phone[MAXLINES];
#else
char *phone[1];
#endif

debug(6,"selecting lines for node %s", ascfnode(addr,0x1f));

phone[0] = NULL;

if((nlent=getnlent(addr)))
    {
    if(!inetaddr && nlent->phone && ((!(nlent->pflag & (NL_DOWN|NL_HOLD|NL_PVT))
                && checkWorkTime(nlent, NULL, -1, -1, -1)) || forcedcalls))
	{
	phone[0]=strdup(nlent->phone);
	debug(6,"nodelist: %s", phone[0]);
	}
    }
else
    {
    debug(6,"node is not listed, using dummy values");
    nlent = getnlent(NULL);
    nlent->pflag = 0;
    nlent->phone = NULL;
    nlent->addr.zone = addr->zone;
    nlent->addr.net = addr->net;
    nlent->addr.node = addr->node;
    nlent->addr.point = addr->point;
    nlent->addr.domain = addr->domain;
    nlent->addr.name = "";
    }
    
if(inetaddr)
    {
    debug(6,"inetaddress: %s", inetaddr);
	lines++;

	tryline = st->tryno % lines;

#ifdef IFCS
	if(shmData)
	{
		shmData->OtherEndLine=tryline;
		shmData->OtherEndLines=lines;
	}
#endif

	call_line=tryline;
	call_lines=lines;

    return nlent;
    }

if (forcedphone)
{
	debug(6,"used forced phone for %s", ascfnode(addr,0x1f));
	return nlent;
}
 
#ifdef HIDDENS	
for (tmp=Override; tmp; tmp=tmp->next)
    if ((tmp->addr->zone == addr->zone) && (tmp->addr->net == addr->net) &&
        (tmp->addr->node == addr->node) && (tmp->addr->point == addr->point) &&
        (phone[0]=parsehidden(nlent, tmp->addr->name)))
	    {
	    debug(6,"override[0]: %s", phone[0]);
	    break;
	    }
	
if(phone[0]) lines++;
   	    
for (tmp=Hidden; tmp; tmp=tmp->next)
    if ((tmp->addr->zone == addr->zone) && (tmp->addr->net == addr->net) && 
        (tmp->addr->node == addr->node) && (tmp->addr->point == addr->point) &&
        (lines < MAXLINES) && (phone[lines]=parsehidden(nlent, tmp->addr->name))) 
	    {
	    debug(6,"hidden[%d]: %s", lines, phone[lines]);
	    lines++;
	    }
#else
if(phone[0]) lines++;
#endif	
	
if(!lines)
    {
    debug(6,"no working lines");
    nlent->phone = NULL;
    return nlent;
    }
	    	    
tryline = st->tryno % lines;

#ifdef IFCS
if(shmData)
    {
    shmData->OtherEndLine=tryline;
    shmData->OtherEndLines=lines;
    }
#endif

call_line=tryline;
call_lines=lines;

strcpy(phonebuf, phone[tryline]);
nlent->phone=phonebuf;

for(i=0; i<lines; i++) free(phone[i]);

return nlent;
}
