#ifndef _IFCS_H
#define _IFCS_H

#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <limits.h>
#include "ftn.h"

/* "-32768:-32768/-32768.-32768@someonenet" */
#define MAX_FTN_ADDR 6+1+6+1+6+1+6+1+10
/* "ifcico v2.14-tx8.8-sc1" */
#define MAX_IFCICO_VER 40
/* "CONNECT 14400/ARQ/V34/LAPM/V42BIS" */
#define MAX_CONNECT 80
/* "115200"*/
#define MAX_BAUD 6
/* 7-3512-340010 */
#define MAX_PHONE 21
/* other info */
#define MAX_INFO 80
#define MAX_LOG 256

typedef struct _shmHead
    {
    key_t Key[UCHAR_MAX + 1];
    }
shmHead_;

typedef struct _shmTransfer
    {
    time_t TrStart, TrTime;
    unsigned long TrSize;
    unsigned long TrFiles;
    unsigned long TrSkip;

    time_t Start;
    char FileName[PATH_MAX+1];
    unsigned long FileSize;
    unsigned long SkipSize;
    unsigned long Pos;    
    unsigned long BlockSize;
    }
shmTransfer_;

/* Segment of shared memory for each task (ifcico) */
typedef struct _shmData
    {
    pid_t Pid;				/* pid of ifcico */
    char tty[PATH_MAX+1];		/* tty used by ifcico */
    unsigned int ttyspeed;

    char Whoami[MAX_FTN_ADDR+1];	/* our main address */
    char Ver[MAX_IFCICO_VER+1];		/* ifcico version string */

    char ConnectStr[MAX_CONNECT+1];	/* connect string from modem */
    char OtherEndPhone[MAX_PHONE+1];	/* remote phone (or CallerID) */
    unsigned char OtherEndLine;		/* remote line number */
    unsigned char OtherEndLines;	/* remote lines number */

    char EMSI_Addr[MAX_FTN_ADDR+1];	/* remote address from EMSI */
    char EMSI_System[MAX_INFO+1];	/* system name from EMSI */
    char EMSI_SySop[MAX_INFO+1];	/* sysop name from EMSI */
    char EMSI_Using[MAX_INFO+1];	/* used remote mailer */    
    char EMSI_Location[MAX_INFO+1];	/* remote location from EMSI */
    char EMSI_Phone[MAX_INFO+1];	/* remote phone from EMSI */
    char EMSI_Baud[MAX_BAUD+1];		/* remote baud from EMSI */
    char EMSI_Flags[MAX_INFO+1];	/* remote flags from EMSI */
    char EMSI_AKA[MAX_INFO+1];		/* remote AKAs from EMSI */
    time_t EMSI_Time;			/* remote time */

    time_t SesStart;			/* session start time */
    unsigned short SesMaster;		/* master session? */
    unsigned short SesProtected;	/* protected session ? */

    shmTransfer_ send;
    shmTransfer_ recv;
  }
shmData_;
#endif
