#ifndef __CRC_H
#define __CRC_H
/*
 *
 * CRC calculating routes
 *  
 */

#define upd_crc32(a, crc) (crc32tab[((int) (crc) ^ (a)) & 0xff] ^ (((crc) >> 8) & 0x00ffffff))
#define upd_crc16ccitt(a, crc) (crc16ccitttab[((crc) ^ (a)) & 0xff] ^ (((crc) >> 8) & 0x00ff))
#define upd_crc16xmodem(a, crc) (crc16xmodemtab[((((crc) >> 8) & 0xff) ^ (a)) & 0xff] ^ ((crc) << 8))
 
extern unsigned long crc32tab[];
extern unsigned short crc16xmodemtab[];
extern unsigned short crc16ccitttab[];

unsigned long crc(char *str);
unsigned long crc32ccitt(char *str, int l);
unsigned long crc32(char *str, int l);
unsigned short crc16ccitt(char *str, int l);
unsigned short crc16xmodem(char *str, int l);
unsigned char checksum(char *str, int l);
#endif
